; Source created with Parsic Version 3.x

; at              : 16/08/02 18.21.08


; Project File    : c:\PROGRA~1\PARSIC\ADC\MWERT2.PIC

; Project Version : 1.0.33

; Created         : 24/06/02 12.35.00

; Last change     : 26/06/02 23.26.00

	PROCESSOR 16F877

	INCLUDE P16F877.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_OFF & _BODEN_ON & _XT_OSC & _LVP_OFF & _CPD_OFF & _DEBUG_OFF

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

ADC0	= 32	; located in Bank 0
ADC0_HI	= 33	; located in Bank 0
S0	= 34	; located in Bank 0
S0_HI	= 35	; located in Bank 0
S1	= 36	; located in Bank 0
S1_HI	= 37	; located in Bank 0
S2	= 38	; located in Bank 0
S2_HI	= 39	; located in Bank 0
S3	= 40	; located in Bank 0
S3_HI	= 41	; located in Bank 0
S4	= 42	; located in Bank 0
S4_HI	= 43	; located in Bank 0
S5	= 44	; located in Bank 0
S5_HI	= 45	; located in Bank 0
S6	= 46	; located in Bank 0
S6_HI	= 47	; located in Bank 0
S7	= 48	; located in Bank 0
S7_HI	= 49	; located in Bank 0
S8	= 50	; located in Bank 0
S8_HI	= 51	; located in Bank 0
S9	= 52	; located in Bank 0
S9_HI	= 53	; located in Bank 0
S10	= 54	; located in Bank 0
S10_HI	= 55	; located in Bank 0
S11	= 56	; located in Bank 0
S11_HI	= 57	; located in Bank 0
S12	= 58	; located in Bank 0
S12_HI	= 59	; located in Bank 0
S13	= 60	; located in Bank 0
S13_HI	= 61	; located in Bank 0
S14	= 62	; located in Bank 0
S14_HI	= 63	; located in Bank 0
ZV1	= 64	; located in Bank 0
ZV1_FD	= 65	; located in Bank 0
S15	= 66	; located in Bank 0
MWERT	= 67	; located in Bank 0
MWERT_HI	= 68	; located in Bank 0
TR1	= 69	; located in Bank 0
TR1_HI	= 70	; located in Bank 0
RAM	= 71	; located in Bank 0
SYS_TMP1	= 115	; located in Bank 0, 1, 2, 3
SYS_TMP2	= 116	; located in Bank 0, 1, 2, 3
SYS_TMP3	= 117	; located in Bank 0, 1, 2, 3
SYS_TMP4	= 118	; located in Bank 0, 1, 2, 3
SYS_TMP5	= 119	; located in Bank 0, 1, 2, 3
SYS_TMP6	= 120	; located in Bank 0, 1, 2, 3
SYS_TMP7	= 121	; located in Bank 0, 1, 2, 3
SYS_WSAV	= 122	; located in Bank 0, 1, 2, 3
SYS_SSAV	= 123	; located in Bank 0, 1, 2, 3
SYS_PSAV	= 124	; located in Bank 0, 1, 2, 3

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	MOVLW HIGH SYS_INIT	; set page
	MOVWF PCLATH
	GOTO SYS_INIT

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV
	MOVFW PCLATH
	MOVWF SYS_PSAV
	CLRF PCLATH

	BCF INTCON,T0IF	; Interrupt quitieren

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	INCF TR1_HI,F

SYS_INT_LABEL_0

EXITINT
	MOVFW SYS_PSAV
	MOVWF PCLATH

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Division 16 - Bit
; OP1 = SYS_TMP1,2
; OP2 = SYS_TMP3,4
;****************************************

SYSDIV16
	MOVFW SYS_TMP3	; Division durch 0 ?
	IORWF SYS_TMP4,W
	BTFSC STATUS,ZERO
	GOTO SYSDIV16_ERROR

	CLRF SYS_TMP5	; Ergebnis lschen
	CLRF SYS_TMP6
	MOVLW 1
	MOVWF SYS_TMP7
SYSDIV16_0
	BTFSC SYS_TMP4,7	; OP2 linksbndig
	GOTO SYSDIV16_1
	INCF SYS_TMP7,F
	BCF STATUS,CARRY
	RLF SYS_TMP3,F
	RLF SYS_TMP4,F
	GOTO SYSDIV16_0

SYSDIV16_1
	MOVFW SYS_TMP4	; OP1 und OP2 vergleichen
	SUBWF SYS_TMP2,W	; F-W -> W
	BTFSS STATUS,ZERO
	GOTO SYSDIV16_2
	MOVFW SYS_TMP3
	SUBWF SYS_TMP1,W	; F-W -> W

SYSDIV16_2
	BTFSS STATUS,CARRY
	GOTO SYSDIV16_3
	MOVFW SYS_TMP4	; OP1-OP2
	SUBWF SYS_TMP2,F	; F-W -> F
	MOVFW SYS_TMP3
	SUBWF SYS_TMP1,F	; F-W -> F
	BTFSS STATUS,CARRY
	DECF SYS_TMP2,F
	BSF STATUS,CARRY
SYSDIV16_3
	RLF SYS_TMP5,F	; Ergebnis aktualisieren
	RLF SYS_TMP6,F
	RRF SYS_TMP4,F	; OP2 nach rechts schieben
	RRF SYS_TMP3,F
	DECFSZ SYS_TMP7,F	; Zhler -1
	GOTO SYSDIV16_1

	RETURN

SYSDIV16_ERROR
	MOVLW 255
	MOVWF SYS_TMP5
	MOVWF SYS_TMP6
	RETURN


;****************************************
; Subroutines
;****************************************

;***************************************************
; Read  -> AN0
;***************************************************

READ_AN0

	MOVLW B'100'
	BSF STATUS,RP0	; Bank 1
	BCF STATUS,RP1	; Bank 1
	MOVWF ADCON1
	BSF TRISA,0
	BSF ADCON1,ADFM	; Right-Justified

	MOVLW B'11000001'	; CH0
	BCF STATUS,RP0	; Bank 0
	MOVWF ADCON0
	MOVLW 5
	MOVWF SYS_TMP1

SYS_ADC_LABEL_0
	DECFSZ SYS_TMP1,F
	GOTO SYS_ADC_LABEL_0

	BSF ADCON0,GO	; Start convert

SYS_ADC_LABEL_1

	BTFSC ADCON0,GO	; ready ?
	GOTO SYS_ADC_LABEL_1	; no

	BSF STATUS,RP0	; Bank 1
	MOVFW ADRESL
	BCF STATUS,RP0	; Bank 0
	MOVWF ADC0
	MOVFW ADRESH
	MOVWF ADC0_HI


	MOVLW 6
	BSF STATUS,RP0	; Bank 1
	MOVWF ADCON1
	MOVLW B'11111111'
	MOVWF TRISA
	
	RETURN


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW B'00000000'
	MOVWF PORTC

	MOVLW B'00000000'
	MOVWF PORTD

	MOVLW B'00000000'
	MOVWF PORTE

	MOVLW 15
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG

	MOVLW 6	; all Digital
	MOVWF ADCON1

; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'11111111'
	MOVWF TRISB

	MOVLW B'11111111'
	MOVWF TRISC

	MOVLW B'11111111'
	MOVWF TRISD

	MOVLW B'00000111'
	MOVWF TRISE

; init vars


; Clear RAM

	BCF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR2
	BSF STATUS,IRP
	MOVLW 16
	MOVWF FSR
CR3
	CLRF INDF
	INCF FSR,F
	MOVLW H'70'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR3
	MOVLW 144
	MOVWF FSR
CR4
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR4


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CALL READ_AN0
;***************************************************
; Multiplexer -> MX1
;***************************************************

	CLRF SYS_TMP1
	BCF STATUS,RP0	; Bank 0
	MOVFW ZV1
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL1

	MOVFW ADC0
	MOVWF S0
	MOVFW ADC0_HI
	MOVWF S0_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL1
	INCF SYS_TMP1,F
	BCF STATUS,RP0	; Bank 0
	MOVFW ZV1
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL2

	MOVFW ADC0
	MOVWF S1
	MOVFW ADC0_HI
	MOVWF S1_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL2
	INCF SYS_TMP1,F
	BCF STATUS,RP0	; Bank 0
	MOVFW ZV1
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL3

	MOVFW ADC0
	MOVWF S2
	MOVFW ADC0_HI
	MOVWF S2_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL3
	INCF SYS_TMP1,F
	BCF STATUS,RP0	; Bank 0
	MOVFW ZV1
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL4

	MOVFW ADC0
	MOVWF S3
	MOVFW ADC0_HI
	MOVWF S3_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL4
	INCF SYS_TMP1,F
	BCF STATUS,RP0	; Bank 0
	MOVFW ZV1
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL5

	MOVFW ADC0
	MOVWF S4
	MOVFW ADC0_HI
	MOVWF S4_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL5
	INCF SYS_TMP1,F
	BCF STATUS,RP0	; Bank 0
	MOVFW ZV1
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL6

	MOVFW ADC0
	MOVWF S5
	MOVFW ADC0_HI
	MOVWF S5_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL6
	INCF SYS_TMP1,F
	BCF STATUS,RP0	; Bank 0
	MOVFW ZV1
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL7

	MOVFW ADC0
	MOVWF S6
	MOVFW ADC0_HI
	MOVWF S6_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL7
	INCF SYS_TMP1,F
	BCF STATUS,RP0	; Bank 0
	MOVFW ZV1
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL8

	MOVFW ADC0
	MOVWF S7
	MOVFW ADC0_HI
	MOVWF S7_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL8

LABEL_MX1_END

;***************************************************
;AF1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW S0_HI
	ADDWF S1_HI,W
	MOVWF S8_HI
	MOVFW S0
	ADDWF S1,W
	MOVWF S8
	BTFSC STATUS,CARRY
	INCF S8_HI,F

LABEL_AF1_EXIT
;***************************************************
;AF2
;***************************************************

	MOVFW S8_HI
	ADDWF S2_HI,W
	MOVWF S9_HI
	MOVFW S8
	ADDWF S2,W
	MOVWF S9
	BTFSC STATUS,CARRY
	INCF S9_HI,F

LABEL_AF2_EXIT
;***************************************************
;AF3
;***************************************************

	MOVFW S9_HI
	ADDWF S3_HI,W
	MOVWF S10_HI
	MOVFW S9
	ADDWF S3,W
	MOVWF S10
	BTFSC STATUS,CARRY
	INCF S10_HI,F

LABEL_AF3_EXIT
;***************************************************
;AF4
;***************************************************

	MOVFW S10_HI
	ADDWF S4_HI,W
	MOVWF S11_HI
	MOVFW S10
	ADDWF S4,W
	MOVWF S11
	BTFSC STATUS,CARRY
	INCF S11_HI,F

LABEL_AF4_EXIT
;***************************************************
;AF5
;***************************************************

	MOVFW S11_HI
	ADDWF S5_HI,W
	MOVWF S12_HI
	MOVFW S11
	ADDWF S5,W
	MOVWF S12
	BTFSC STATUS,CARRY
	INCF S12_HI,F

LABEL_AF5_EXIT
;***************************************************
;AF6
;***************************************************

	MOVFW S12_HI
	ADDWF S6_HI,W
	MOVWF S13_HI
	MOVFW S12
	ADDWF S6,W
	MOVWF S13
	BTFSC STATUS,CARRY
	INCF S13_HI,F

LABEL_AF6_EXIT
;***************************************************
;AF7
;***************************************************

	MOVFW S13_HI
	ADDWF S7_HI,W
	MOVWF S14_HI
	MOVFW S13
	ADDWF S7,W
	MOVWF S14
	BTFSC STATUS,CARRY
	INCF S14_HI,F

LABEL_AF7_EXIT
;***************************************************
; Zhler -> ZV1
;***************************************************

	BTFSS S15,1	; Reset ?
	GOTO LABEL_ZV1_COUNT
	CLRF ZV1
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S15,2
	GOTO LABEL_ZV1_SETFD
	BTFSC ZV1_FD,0
	GOTO LABEL_ZV1_SETFD

	BSF ZV1_FD,0


	BTFSC S15,0	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV1_BACKWARD

	INCF ZV1,F
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_BACKWARD
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	DECF ZV1,F

LABEL_ZV1_SETOUT


LABEL_ZV1_SETFD

; Test auf negative Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S15,2
	GOTO LABEL_ZV1_EXIT
	BCF ZV1_FD,0

LABEL_ZV1_EXIT

;***************************************************
; GND
;***************************************************

	BCF S15,0	; immer Low

;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVLW 7
	SUBWF ZV1,W	; F - W -> W

LABEL_IF1_CHECK
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S15,1
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S15,1

LABEL_IF1_EXIT
;***************************************************
;AF8
;***************************************************

	MOVFW S14
	MOVWF SYS_TMP1
	MOVFW S14_HI
	MOVWF SYS_TMP2
	MOVLW LOW 8
	MOVWF SYS_TMP3
	MOVLW HIGH 8
	MOVWF SYS_TMP4
	MOVLW HIGH SYSDIV16
	MOVWF PCLATH
	CALL SYSDIV16
	MOVLW HIGH LABEL_AF8
	MOVWF PCLATH
LABEL_AF8
	MOVFW SYS_TMP5
	MOVWF MWERT
	MOVFW SYS_TMP6
	MOVWF MWERT_HI

LABEL_AF8_EXIT
;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 1	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 135
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 1	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 135
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S15,2
	GOTO LABEL_TR1_CLR
	BSF S15,2
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S15,2
LABEL_TR1_ENDE

;****************************************

	GOTO MAIN


	END

